unit cpu;

interface

  procedure CpuReset;
  procedure CpuRun;


implementation

  uses make_def, make_dc, srcdst;

  procedure CpuReset;
  begin
    cpuctrl := $0C80;
{ reset vector }
    ptrw(@reg[R7])^ := ptrw(@rom[0])^;
    psw := ptrw(@rom[2])^;
  end {CpuReset};


{ execute a single instruction }
  procedure CpuRun;
  var
    vector: pointer;
  begin
{ start the CPU clock when any key pressed }
    if (KeyCode1 <> 0) or (KeyCode2 <> 0) then cpuctrl := cpuctrl or $0400;
{ CPU clock running? }
    if (cpuctrl and $0400) <> 0 then
    begin
{ interrupt from the STOP key? }
      if ((KeyCode1 = 42) or (KeyCode2 = 42))	{ STOP key pressed? }
        and ((kbdrows and 2) <> 0)		{ row 1 selected? }
        and ((psw and I_bit) = 0) 		{ interrupts enabled? }
        then
      begin
        dummyptr := GetSrcW($26);		{ SP <- SP-2 }
        if (loc and 1) = 0 then
        begin
          ptrw(DstPtr)^ := psw;			{ (SP) <- psw }
          dummyptr := GetSrcW($26);		{ SP <- SP-2 }
          ptrw(DstPtr)^ := ptrw(@reg[R7])^;	{ (SP) <- PC }
          ptrw(@reg[R7])^ := ptrw(@rom[$0078])^;  { interrupt vector }
          psw := ptrw(@rom[$007A])^;
          vector := nil;
        end
        else vector := @rom[4];		{ odd address }
      end
{ execute an instruction or handle an exception }
      else if (ptrw(@reg[R7])^ and 1) = 0 then	{ even address }
      begin
        code := ptrw(GetSrcW($17))^;
        vector := Make_DC0;
      end
      else vector := @rom[4];		{ odd address }
      if vector <> nil then
      begin
        ptrw(@reg[R7])^ := ptrw(vector)^;
        psw := ptrw(PChar(vector) + 2)^;
      end {if};
    end {if};
  end {CpuRun};

end.
